import React from 'react';
import * as glamor from './index';

// import shallowCompare from 'react-addons-shallow-compare'
var withKeys = function withKeys() {
  for (var _len = arguments.length, keys = Array(_len), _key = 0; _key < _len; _key++) {
    keys[_key] = arguments[_key];
  }

  return keys.reduce(function (o, k) {
    return o[k] = true, o;
  }, {});
};

// need this list for SSR. 2k gzipped. worth the cost. 
var propNames = withKeys('alignContent', 'alignItems', 'alignSelf', 'alignmentBaseline', 'all', 'animation', 'animationDelay', 'animationDirection', 'animationDuration', 'animationFillMode', 'animationIterationCount', 'animationName', 'animationPlayState', 'animationTimingFunction', 'backfaceVisibility', 'background', 'backgroundAttachment', 'backgroundBlendMode', 'backgroundClip', 'backgroundColor', 'backgroundImage', 'backgroundOrigin', 'backgroundPosition', 'backgroundPositionX', 'backgroundPositionY', 'backgroundRepeat', 'backgroundRepeatX', 'backgroundRepeatY', 'backgroundSize', 'baselineShift', 'border', 'borderBottom', 'borderBottomColor', 'borderBottomLeftRadius', 'borderBottomRightRadius', 'borderBottomStyle', 'borderBottomWidth', 'borderCollapse', 'borderColor', 'borderImage', 'borderImageOutset', 'borderImageRepeat', 'borderImageSlice', 'borderImageSource', 'borderImageWidth', 'borderLeft', 'borderLeftColor', 'borderLeftStyle', 'borderLeftWidth', 'borderRadius', 'borderRight', 'borderRightColor', 'borderRightStyle', 'borderRightWidth', 'borderSpacing', 'borderStyle', 'borderTop', 'borderTopColor', 'borderTopLeftRadius', 'borderTopRightRadius', 'borderTopStyle', 'borderTopWidth', 'borderWidth', 'bottom', 'boxShadow', 'boxSizing', 'breakAfter', 'breakBefore', 'breakInside', 'bufferedRendering', 'captionSide', 'clear', 'clip', 'clipPath', 'clipRule', 'color', 'colorInterpolation', 'colorInterpolationFilters', 'colorRendering', 'columnCount', 'columnFill', 'columnGap', 'columnRule', 'columnRuleColor', 'columnRuleStyle', 'columnRuleWidth', 'columnSpan', 'columnWidth', 'columns', 'contain', 'content', 'counterIncrement', 'counterReset', 'cursor', 'cx', 'cy', 'd', 'direction', 'display', 'dominantBaseline', 'emptyCells', 'fill', 'fillOpacity', 'fillRule', 'filter', 'flex', 'flexBasis', 'flexDirection', 'flexFlow', 'flexGrow', 'flexShrink', 'flexWrap', 'float', 'floodColor', 'floodOpacity', 'font', 'fontFamily', 'fontFeatureSettings', 'fontKerning', 'fontSize', 'fontStretch', 'fontStyle', 'fontVariant', 'fontVariantCaps', 'fontVariantLigatures', 'fontVariantNumeric', 'fontWeight', 'height', 'imageRendering', 'isolation', 'justifyContent', 'left', 'letterSpacing', 'lightingColor', 'lineHeight', 'listStyle', 'listStyleImage', 'listStylePosition', 'listStyleType', 'margin', 'marginBottom', 'marginLeft', 'marginRight', 'marginTop', 'marker', 'markerEnd', 'markerMid', 'markerStart', 'mask', 'maskType', 'maxHeight', 'maxWidth', 'maxZoom', 'minHeight', 'minWidth', 'minZoom', 'mixBlendMode', 'motion', 'motionOffset', 'motionPath', 'motionRotation', 'objectFit', 'objectPosition', 'opacity', 'order', 'orientation', 'orphans', 'outline', 'outlineColor', 'outlineOffset', 'outlineStyle', 'outlineWidth', 'overflow', 'overflowWrap', 'overflowX', 'overflowY', 'padding', 'paddingBottom', 'paddingLeft', 'paddingRight', 'paddingTop', 'page', 'pageBreakAfter', 'pageBreakBefore', 'pageBreakInside', 'paintOrder', 'perspective', 'perspectiveOrigin', 'pointerEvents', 'position', 'quotes', 'r', 'resize', 'right', 'rx', 'ry', 'shapeImageThreshold', 'shapeMargin', 'shapeOutside', 'shapeRendering', 'size', 'speak', 'src', 'stopColor', 'stopOpacity', 'stroke', 'strokeDasharray', 'strokeDashoffset', 'strokeLinecap', 'strokeLinejoin', 'strokeMiterlimit', 'strokeOpacity', 'strokeWidth', 'tabSize', 'tableLayout', 'textAlign', 'textAlignLast', 'textAnchor', 'textCombineUpright', 'textDecoration', 'textIndent', 'textOrientation', 'textOverflow', 'textRendering', 'textShadow', 'textTransform', 'top', 'touchAction', 'transform', 'transformOrigin', 'transformStyle', 'transition', 'transitionDelay', 'transitionDuration', 'transitionProperty', 'transitionTimingFunction', 'unicodeBidi', 'unicodeRange', 'userZoom', 'vectorEffect', 'verticalAlign', 'visibility', 'appRegion', 'appearance', 'backgroundClip', 'backgroundOrigin', 'borderAfter', 'borderAfterColor', 'borderAfterStyle', 'borderAfterWidth', 'borderBefore', 'borderBeforeColor', 'borderBeforeStyle', 'borderBeforeWidth', 'borderEnd', 'borderEndColor', 'borderEndStyle', 'borderEndWidth', 'borderHorizontalSpacing', 'borderImage', 'borderStart', 'borderStartColor', 'borderStartStyle', 'borderStartWidth', 'borderVerticalSpacing', 'boxAlign', 'boxDecorationBreak', 'boxDirection', 'boxFlex', 'boxFlexGroup', 'boxLines', 'boxOrdinalGroup', 'boxOrient', 'boxPack', 'boxReflect', 'clipPath', 'columnBreakAfter', 'columnBreakBefore', 'columnBreakInside', 'filter', 'fontSizeDelta', 'fontSmoothing', 'highlight', 'hyphenateCharacter', 'lineBreak', 'lineClamp', 'locale', 'logicalHeight', 'logicalWidth', 'marginAfter', 'marginAfterCollapse', 'marginBefore', 'marginBeforeCollapse', 'marginBottomCollapse', 'marginCollapse', 'marginEnd', 'marginStart', 'marginTopCollapse', 'mask', 'maskBoxImage', 'maskBoxImageOutset', 'maskBoxImageRepeat', 'maskBoxImageSlice', 'maskBoxImageSource', 'maskBoxImageWidth', 'maskClip', 'maskComposite', 'maskImage', 'maskOrigin', 'maskPosition', 'maskPositionX', 'maskPositionY', 'maskRepeat', 'maskRepeatX', 'maskRepeatY', 'maskSize', 'maxLogicalHeight', 'maxLogicalWidth', 'minLogicalHeight', 'minLogicalWidth', 'paddingAfter', 'paddingBefore', 'paddingEnd', 'paddingStart', 'perspectiveOriginX', 'perspectiveOriginY', 'printColorAdjust', 'rtlOrdering', 'rubyPosition', 'tapHighlightColor', 'textCombine', 'textDecorationsInEffect', 'textEmphasis', 'textEmphasisColor', 'textEmphasisPosition', 'textEmphasisStyle', 'textFillColor', 'textOrientation', 'textSecurity', 'textStroke', 'textStrokeColor', 'textStrokeWidth', 'transformOriginX', 'transformOriginY', 'transformOriginZ', 'userDrag', 'userModify', 'userSelect', 'writingMode', 'whiteSpace', 'widows', 'width', 'willChange', 'wordBreak', 'wordSpacing', 'wordWrap', 'writingMode', 'x', 'y', 'zIndex', 'zoom');

var pseudos = withKeys(
// pseudoclasses
'active', 'any', 'checked', 'disabled', 'empty', 'enabled', '_default', 'first', 'firstChild', 'firstOfType', 'fullscreen', 'focus', 'hover', 'indeterminate', 'inRange', 'invalid', 'lastChild', 'lastOfType', 'left', 'link', 'onlyChild', 'onlyOfType', 'optional', 'outOfRange', 'readOnly', 'readWrite', 'required', 'right', 'root', 'scope', 'target', 'valid', 'visited',
// pseudoelements
'after', 'before', 'firstLetter', 'firstLine', 'selection', 'backdrop', 'placeholder');

var parameterizedPseudos = withKeys('dir', 'lang', 'not', 'nthChild', 'nthLastChild', 'nthLastOfType', 'nthOfType');

// const STYLE_PROP_NAMES = propNames.reduce((styles, key) => {
//   styles[key] = true
//   return styles
// }, { label: true })

// /^(webkit|moz|ms)([A-Za-z]+)/
var prefixCache = {};
function prefixed(key) {
  if (prefixCache.hasOwnProperty(key)) {
    return prefixCache[key];
  }
  var m = /^(webkit|moz|ms|o){1}([A-Z][A-Za-z]+)/.exec(key),
      subKey = void 0;
  if (m) {
    subKey = m[2];
    subKey = subKey.charAt(0).toLowerCase() + subKey.slice(1);
  }
  prefixCache[key] = subKey;
  return subKey;
}

function isHandler(key) {
  return !!/^on[A-Z]/.exec(key);
}

var splitStyles = function splitStyles(combinedProps) {
  var props = {},
      gStyle = [],
      style = {};
  Object.keys(combinedProps).forEach(function (key) {

    if (propNames[key]) {
      style[key] = combinedProps[key];
    } else if (prefixed(key) && propNames[prefixed(key)]) {
      style[key] = combinedProps[key];
    } else if (key === 'css') {
      Object.assign(style, combinedProps[key]);
    } else if (pseudos[key] >= 0) {
      gStyle.push(glamor[key](combinedProps[key]));
    } else if (parameterizedPseudos[key] || key === 'media' || key === 'select') {
      gStyle.push(glamor[key].apply(glamor, babelHelpers.toConsumableArray(combinedProps[key])));
    } else if (key === 'merge' || key === 'compose') {
      if (Array.isArray(combinedProps[key])) {
        gStyle.splice.apply(gStyle, [gStyle.length, 0].concat(babelHelpers.toConsumableArray(combinedProps[key])));
      } else {
        gStyle.splice(gStyle.length, 0, combinedProps[key]);
      }
    } else if (isHandler(key)) {
      props[key] = combinedProps[key];
    } else if (key === 'props') {
      Object.assign(props, combinedProps[key]);
    } else if (key === 'style' || key === 'className' || key === 'children') {
      props[key] = combinedProps[key];
    } else {
      // console.warn('irregular key ' + key)    //eslint-disable-line no-console
      props[key] = combinedProps[key];
    }
  });
  return babelHelpers.extends({}, gStyle.length > 0 ? glamor.merge.apply(glamor, [style].concat(gStyle)) : Object.keys(style).length > 0 ? glamor.style(style) : {}, props);
};

export var View = function (_React$Component) {
  babelHelpers.inherits(View, _React$Component);

  function View() {
    babelHelpers.classCallCheck(this, View);
    return babelHelpers.possibleConstructorReturn(this, (View.__proto__ || Object.getPrototypeOf(View)).apply(this, arguments));
  }

  babelHelpers.createClass(View, [{
    key: 'render',
    value: function render() {
      var _props = this.props;
      var Component = _props.component;
      var props = babelHelpers.objectWithoutProperties(_props, ['component']);

      return React.createElement(Component, splitStyles(props));
    }
  }]);
  return View;
}(React.Component);

View.defaultProps = {
  component: 'div'
};
export var Block = function (_React$Component2) {
  babelHelpers.inherits(Block, _React$Component2);

  function Block() {
    babelHelpers.classCallCheck(this, Block);
    return babelHelpers.possibleConstructorReturn(this, (Block.__proto__ || Object.getPrototypeOf(Block)).apply(this, arguments));
  }

  babelHelpers.createClass(Block, [{
    key: 'render',
    value: function render() {
      return React.createElement(View, babelHelpers.extends({ display: 'block' }, this.props));
    }
  }]);
  return Block;
}(React.Component);

export var InlineBlock = function (_React$Component3) {
  babelHelpers.inherits(InlineBlock, _React$Component3);

  function InlineBlock() {
    babelHelpers.classCallCheck(this, InlineBlock);
    return babelHelpers.possibleConstructorReturn(this, (InlineBlock.__proto__ || Object.getPrototypeOf(InlineBlock)).apply(this, arguments));
  }

  babelHelpers.createClass(InlineBlock, [{
    key: 'render',
    value: function render() {
      return React.createElement(View, babelHelpers.extends({ display: 'inline-block' }, this.props));
    }
  }]);
  return InlineBlock;
}(React.Component);

export var Flex = function (_React$Component4) {
  babelHelpers.inherits(Flex, _React$Component4);

  function Flex() {
    babelHelpers.classCallCheck(this, Flex);
    return babelHelpers.possibleConstructorReturn(this, (Flex.__proto__ || Object.getPrototypeOf(Flex)).apply(this, arguments));
  }

  babelHelpers.createClass(Flex, [{
    key: 'render',
    value: function render() {
      return React.createElement(View, babelHelpers.extends({ display: 'flex' }, this.props));
    }
  }]);
  return Flex;
}(React.Component);

export var Row = function (_React$Component5) {
  babelHelpers.inherits(Row, _React$Component5);

  function Row() {
    babelHelpers.classCallCheck(this, Row);
    return babelHelpers.possibleConstructorReturn(this, (Row.__proto__ || Object.getPrototypeOf(Row)).apply(this, arguments));
  }

  babelHelpers.createClass(Row, [{
    key: 'render',
    value: function render() {
      return React.createElement(Flex, babelHelpers.extends({ flexDirection: 'row' }, this.props));
    }
  }]);
  return Row;
}(React.Component);

export var Column = function (_React$Component6) {
  babelHelpers.inherits(Column, _React$Component6);

  function Column() {
    babelHelpers.classCallCheck(this, Column);
    return babelHelpers.possibleConstructorReturn(this, (Column.__proto__ || Object.getPrototypeOf(Column)).apply(this, arguments));
  }

  babelHelpers.createClass(Column, [{
    key: 'render',
    value: function render() {
      return React.createElement(Flex, babelHelpers.extends({ flexDirection: 'column' }, this.props));
    }
  }]);
  return Column;
}(React.Component);